#include "wqueue.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char out[100];
int thread_id;

/* En funktion der udskriver en int 5 gange med en lille pause imellem */
void print_int(void *data) {
  int i;
  for(i=0; i<5;i++){
    printf("print_int(): %d\n", *((int*) data));
    sleep(1);
  }
}

/* En funktion der udskriver det medleverede data */
void print_res(void *data) {
    printf("print_res(): %s\n", (char *)data);
}


/* bruger lidt tid p ikke at lave noget, og stter 
   derefter nogle printjobs i ken.
   Funktionen bruges til at teste at trde der gr i
   wait bliver vkket igen nr der er nyt arbejde i ken
*/
void calc2(void *data) {

  int i;
  /* lav lidt ingenting */
  for(i=0; i<3;i++){
    sleep(1);
  }

  /* st nogle nye jobs i ken */
  thread_id = pthread_self();
  sprintf(out, "thread_id=%d\n", thread_id);
  wqueue_ts_insert(head, 9, print_res, out);
  thread_id++;
  sprintf(out, "thread_id=%d\n", thread_id);
  wqueue_ts_insert(head, 9, print_res, out);
  thread_id++;
  sprintf(out, "thread_id=%d\n", thread_id);
  wqueue_ts_insert(head, 9, print_res, out);
}

/* en funktion der summerer to tal og konverterer resultatet til en streng og udskriver
det ved at indstte en ny arbejdsopgave, der anvender print_res. */
void calc(void *data) {
    int *op = data, sum;

    sum = op[0] + op[1];
    sprintf(out, "sum=%d\n", sum);

    wqueue_ts_insert(head, 10, print_res, out);
}

int main()
{
  /* initialisering af k: */
  head = (wqueue_t*)init_queue();

  int op[] = {15, 7};
  int op1[] = {5, 4};
  int op2[] = {2, 8};
  int op3[] = {1, 3};

  /* til at tjekke at trdene skiftes til at f kretid */
  
  wqueue_ts_insert(head, 9, print_int, op1);
  wqueue_ts_insert(head, 9, print_int, op2);
  

  /* til at tjecke at ventende trde vkkes igen */
  /*
    wqueue_ts_insert(head, 9, calc2, op2);
  */

  /* til flere tests... her er det at der sker underlige
     ting hvis calc() indstter print_res i arbejdsken
     med en lavere eller samme prioritet som
     arbejdsopgaverne herunder...
     I de tilflde vil den udtage det samme job flere gange.
     Indstter print_res arbejdsopgaverne med hjere prioritet
     en dem herunder, s udfres testen rigtigt.
   */
  /*
  wqueue_ts_insert(head, 1, calc, op);
  wqueue_ts_insert(head, 3, calc, op1);
  wqueue_ts_insert(head, 2, calc, op2);
  wqueue_ts_insert(head, 1, calc, op3);
  */

  wqueue_thread_pool(head, 3);

  printf("Done.\n");

  pthread_exit(NULL);
  return 0;
}
